import * as i0 from '@angular/core';
import { Injectable, forwardRef, Component, Input, ViewChild, NgModule } from '@angular/core';
import * as i1 from '@ng-bootstrap/ng-bootstrap';
import { NgbDatepicker, NgbPopover, NgbModule } from '@ng-bootstrap/ng-bootstrap';
import * as i3 from '@angular/forms';
import { NgControl, NG_VALUE_ACCESSOR, FormsModule, ReactiveFormsModule } from '@angular/forms';
import * as i4 from '@angular/common';
import { DatePipe, CommonModule } from '@angular/common';
import { noop } from 'rxjs';
import * as i2 from '@fortawesome/angular-fontawesome';
import { FontAwesomeModule } from '@fortawesome/angular-fontawesome';

class NgBootstrapDatetimeAngularService {
    constructor() { }
}
NgBootstrapDatetimeAngularService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgBootstrapDatetimeAngularService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
NgBootstrapDatetimeAngularService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgBootstrapDatetimeAngularService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgBootstrapDatetimeAngularService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class NgBootstrapDatetimeAngularComponent {
    constructor(config, inj) {
        this.config = config;
        this.inj = inj;
        this.inputDatetimeFormat = 'd/M/yyyy H:mm:ss';
        this.placeholder = "";
        this.hourStep = 1;
        this.minuteStep = 15;
        this.secondStep = 30;
        this.seconds = true;
        this.disabled = false;
        this.onTouched = noop;
        this.onChange = noop;
        config.autoClose = 'outside';
        config.placement = 'auto';
    }
    ngOnInit() {
        // tslint:disable-next-line: deprecation
        this.ngControl = this.inj.get(NgControl);
    }
    ngAfterViewInit() {
    }
    writeValue(newModel) {
        if (newModel) {
            const myDate = new Date(newModel); //moment(newModel).toDate();
            this.dateStruct = {
                year: myDate.getFullYear(),
                month: myDate.getMonth() + 1,
                day: myDate.getDate()
            };
            this.timeStruct = {
                hour: myDate.getHours(),
                minute: myDate.getMinutes(),
                second: myDate.getSeconds()
            };
            this.setDateStringModel();
        }
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    onInputChange($event) {
    }
    onDateChange(event) {
        this.setDateStringModel();
    }
    onTimeChange(event) {
        this.setDateStringModel();
    }
    setDateStringModel() {
        if (!this.timeStruct) {
            const dateA = new Date();
            this.timeStruct = {
                hour: dateA.getHours(),
                minute: dateA.getMinutes(),
                second: dateA.getSeconds()
            };
        }
        if (this.dateStruct) {
            this.date = new Date(this.dateStruct.year, this.dateStruct.month - 1, this.dateStruct.day, this.timeStruct.hour, this.timeStruct.minute, this.timeStruct.second);
            this.onChange(this.date);
        }
    }
    inputBlur($event) {
        this.onTouched();
    }
}
NgBootstrapDatetimeAngularComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgBootstrapDatetimeAngularComponent, deps: [{ token: i1.NgbPopoverConfig }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component });
NgBootstrapDatetimeAngularComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.4", type: NgBootstrapDatetimeAngularComponent, selector: "ng-bootstrap-datetime-angular", inputs: { inputDatetimeFormat: "inputDatetimeFormat", placeholder: "placeholder", hourStep: "hourStep", minuteStep: "minuteStep", secondStep: "secondStep", seconds: "seconds", disabled: "disabled" }, providers: [
        DatePipe,
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NgBootstrapDatetimeAngularComponent),
            multi: true
        }
    ], viewQueries: [{ propertyName: "dp", first: true, predicate: NgbDatepicker, descendants: true }, { propertyName: "popover", first: true, predicate: NgbPopover, descendants: true }], ngImport: i0, template: "<div class=\"input-group mr-2\">\r\n  <input\r\n    [placeholder]=\"placeholder\"\r\n    [ngClass]=\"ngControl?.valid ? 'ng-valid' : 'ng-invalid'\"\r\n    class=\"form-control\"\r\n    (blur)=\"inputBlur($event)\"\r\n    [ngModel]=\"date | date: inputDatetimeFormat\"\r\n    (change)=\"onInputChange($event)\"\r\n    [disabled]=\"disabled\"\r\n  />\r\n\r\n  <div class=\"input-group-append\">\r\n    <button\r\n      class=\"btn btn-outline-secondary\"\r\n      [ngbPopover]=\"calendarContent\"\r\n      [disabled]=\"disabled\"\r\n      type=\"button\"\r\n    >\r\n      <fa-icon [icon]=\"['fas','calendar']\"></fa-icon>\r\n    </button>\r\n  </div>\r\n</div>\r\n\r\n<ng-template #calendarContent>\r\n  <div>\r\n    <div>\r\n      <ngb-datepicker\r\n        #dp\r\n        name=\"datepicker\"\r\n        [(ngModel)]=\"dateStruct\"\r\n        (ngModelChange)=\"onDateChange($event)\"\r\n      ></ngb-datepicker>\r\n      <ngb-timepicker\r\n        meridian=\"true\"\r\n        [seconds]=\"false\"\r\n        #tp\r\n        name=\"timepicker\"\r\n        [(ngModel)]=\"timeStruct\"\r\n        (ngModelChange)=\"onTimeChange($event)\"\r\n        [seconds]=\"seconds\"\r\n        [hourStep]=\"hourStep\"\r\n        [minuteStep]=\"minuteStep\"\r\n      ></ngb-timepicker>\r\n    </div>\r\n  </div>\r\n</ng-template>\r\n", components: [{ type: i2.FaIconComponent, selector: "fa-icon", inputs: ["icon", "title", "spin", "pulse", "mask", "styles", "flip", "size", "pull", "border", "inverse", "symbol", "rotate", "fixedWidth", "classes", "transform", "a11yRole"] }, { type: i1.NgbDatepicker, selector: "ngb-datepicker", inputs: ["dayTemplate", "dayTemplateData", "displayMonths", "firstDayOfWeek", "footerTemplate", "markDisabled", "maxDate", "minDate", "navigation", "outsideDays", "showWeekNumbers", "startDate", "weekdays"], outputs: ["navigate", "dateSelect"], exportAs: ["ngbDatepicker"] }, { type: i1.NgbTimepicker, selector: "ngb-timepicker", inputs: ["meridian", "spinners", "seconds", "hourStep", "minuteStep", "secondStep", "readonlyInputs", "size"] }], directives: [{ type: i3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i4.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { type: i1.NgbPopover, selector: "[ngbPopover]", inputs: ["animation", "autoClose", "ngbPopover", "popoverTitle", "placement", "triggers", "container", "disablePopover", "popoverClass", "openDelay", "closeDelay"], outputs: ["shown", "hidden"], exportAs: ["ngbPopover"] }], pipes: { "date": i4.DatePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgBootstrapDatetimeAngularComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ng-bootstrap-datetime-angular', styles: [], providers: [
                        DatePipe,
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NgBootstrapDatetimeAngularComponent),
                            multi: true
                        }
                    ], template: "<div class=\"input-group mr-2\">\r\n  <input\r\n    [placeholder]=\"placeholder\"\r\n    [ngClass]=\"ngControl?.valid ? 'ng-valid' : 'ng-invalid'\"\r\n    class=\"form-control\"\r\n    (blur)=\"inputBlur($event)\"\r\n    [ngModel]=\"date | date: inputDatetimeFormat\"\r\n    (change)=\"onInputChange($event)\"\r\n    [disabled]=\"disabled\"\r\n  />\r\n\r\n  <div class=\"input-group-append\">\r\n    <button\r\n      class=\"btn btn-outline-secondary\"\r\n      [ngbPopover]=\"calendarContent\"\r\n      [disabled]=\"disabled\"\r\n      type=\"button\"\r\n    >\r\n      <fa-icon [icon]=\"['fas','calendar']\"></fa-icon>\r\n    </button>\r\n  </div>\r\n</div>\r\n\r\n<ng-template #calendarContent>\r\n  <div>\r\n    <div>\r\n      <ngb-datepicker\r\n        #dp\r\n        name=\"datepicker\"\r\n        [(ngModel)]=\"dateStruct\"\r\n        (ngModelChange)=\"onDateChange($event)\"\r\n      ></ngb-datepicker>\r\n      <ngb-timepicker\r\n        meridian=\"true\"\r\n        [seconds]=\"false\"\r\n        #tp\r\n        name=\"timepicker\"\r\n        [(ngModel)]=\"timeStruct\"\r\n        (ngModelChange)=\"onTimeChange($event)\"\r\n        [seconds]=\"seconds\"\r\n        [hourStep]=\"hourStep\"\r\n        [minuteStep]=\"minuteStep\"\r\n      ></ngb-timepicker>\r\n    </div>\r\n  </div>\r\n</ng-template>\r\n" }]
        }], ctorParameters: function () { return [{ type: i1.NgbPopoverConfig }, { type: i0.Injector }]; }, propDecorators: { inputDatetimeFormat: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], hourStep: [{
                type: Input
            }], minuteStep: [{
                type: Input
            }], secondStep: [{
                type: Input
            }], seconds: [{
                type: Input
            }], disabled: [{
                type: Input
            }], dp: [{
                type: ViewChild,
                args: [NgbDatepicker]
            }], popover: [{
                type: ViewChild,
                args: [NgbPopover]
            }] } });

class NgBootstrapDatetimeAngularModule {
}
NgBootstrapDatetimeAngularModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgBootstrapDatetimeAngularModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgBootstrapDatetimeAngularModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgBootstrapDatetimeAngularModule, declarations: [NgBootstrapDatetimeAngularComponent], imports: [FormsModule,
        NgbModule,
        CommonModule,
        ReactiveFormsModule,
        FontAwesomeModule], exports: [NgBootstrapDatetimeAngularComponent] });
NgBootstrapDatetimeAngularModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgBootstrapDatetimeAngularModule, imports: [[
            FormsModule,
            NgbModule,
            CommonModule,
            ReactiveFormsModule,
            FontAwesomeModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.4", ngImport: i0, type: NgBootstrapDatetimeAngularModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgBootstrapDatetimeAngularComponent],
                    imports: [
                        FormsModule,
                        NgbModule,
                        CommonModule,
                        ReactiveFormsModule,
                        FontAwesomeModule
                    ],
                    exports: [NgBootstrapDatetimeAngularComponent]
                }]
        }] });

/*
 * Public API Surface of ng-bootstrap-datetime-angular
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgBootstrapDatetimeAngularComponent, NgBootstrapDatetimeAngularModule, NgBootstrapDatetimeAngularService };
//# sourceMappingURL=ng-bootstrap-datetime-angular-13.mjs.map
